import React from 'react';
import TextField from '@material-ui/core/TextField';
var field = {
  operators: [{
    value: '=',
    label: '='
  }, {
    value: '>',
    label: '>'
  }, {
    value: '<',
    label: '<'
  }, {
    value: '!=',
    label: '!='
  }, {
    value: '<=',
    label: '<='
  }, {
    value: '>=',
    label: '>='
  }, {
    value: 'like',
    label: 'like'
  }, {
    value: '!like',
    label: '!like'
  }],
  defaultOperator: '=',
  filter: function filter(value, q) {
    var operator = q.operator,
        qv = q.value;

    if (qv !== '') {
      var queryValue = parseFloat(qv);

      switch (operator) {
        case '=':
          return value === queryValue;

        case '>':
          return value > queryValue;

        case '<':
          return value < queryValue;

        case '!=':
          return value !== queryValue;

        case '<=':
          return value <= queryValue;

        case '>=':
          return value >= queryValue;

        case 'like':
          return value.toString().indexOf(queryValue.toString()) !== -1;

        case '!like':
          return value.toString().indexOf(queryValue.toString()) === -1;

        default:
          return false;
      }
    } else {
      return true;
    }
  },
  sort: function sort(orientation, a, b) {
    return (a - b) * orientation;
  },
  render: function render(_ref, _onChange) {
    var _ref$value = _ref.value,
        value = _ref$value === void 0 ? '' : _ref$value;
    return /*#__PURE__*/React.createElement(TextField, {
      variant: "outlined",
      style: {
        padding: 1
      },
      type: "number",
      value: value,
      fullWidth: true,
      onChange: function onChange(e) {
        return _onChange({
          value: e.target.value
        });
      }
    });
  }
};
export default field;