"use strict";

exports.__esModule = true;
exports.default = void 0;

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Context = _interopRequireDefault(require("./Context"));

var _useMediaQuery = _interopRequireDefault(require("@material-ui/core/useMediaQuery"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Provider = function Provider(_ref) {
  var appConfig = _ref.appConfig,
      children = _ref.children,
      _ref$persistKey = _ref.persistKey,
      persistKey = _ref$persistKey === void 0 ? 'menu' : _ref$persistKey;

  var _ref2 = appConfig || {},
      menu = _ref2.menu;

  var _ref3 = menu || {},
      _ref3$useMini = _ref3.useMini,
      useMini = _ref3$useMini === void 0 ? true : _ref3$useMini;

  var _useState = (0, _react.useState)(true),
      isDesktopOpen = _useState[0],
      setDesktopOpen = _useState[1];

  var _useState2 = (0, _react.useState)(false),
      isMobileOpen = _useState2[0],
      setMobileOpen = _useState2[1];

  var _useState3 = (0, _react.useState)(useMini),
      useMiniMode = _useState3[0],
      setMiniMode = _useState3[1];

  var _useState4 = (0, _react.useState)(false),
      isAuthMenuOpen = _useState4[0],
      setAuthMenuOpen = _useState4[1];

  var _useState5 = (0, _react.useState)(false),
      isMini = _useState5[0],
      setMini = _useState5[1];

  var isDesktop = (0, _useMediaQuery.default)('(min-width:600px)');
  var isDesktopKey = persistKey + ":isDesktopOpen";
  var isMiniKey = persistKey + ":isMini";
  var isUseMiniModeKey = persistKey + ":isUseMiniModeKey";
  (0, _react.useEffect)(function () {
    var persistDesktopOpen = localStorage.getItem(isDesktopKey);
    var persistMini = localStorage.getItem(isMiniKey);
    var persistMiniMode = localStorage.getItem(isUseMiniModeKey);

    if (persistDesktopOpen) {
      setDesktopOpen(persistDesktopOpen === 'true');
    }

    if (persistMini) {
      setMini(persistMini === 'true');
    }

    if (persistMiniMode) {
      setMiniMode(persistMiniMode === 'true');
    }
  }, [isDesktopKey, isMiniKey, isUseMiniModeKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(isDesktopKey, JSON.stringify(isDesktopOpen));
    } catch (error) {
      console.warn(error);
    }
  }, [isDesktopOpen, isDesktopKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(isMiniKey, JSON.stringify(isMini));
    } catch (error) {
      console.warn(error);
    }
  }, [isMini, isMiniKey]);
  (0, _react.useEffect)(function () {
    try {
      localStorage.setItem(isUseMiniModeKey, JSON.stringify(useMiniMode));

      if (!useMiniMode) {
        setMini(useMiniMode);
      }
    } catch (error) {
      console.warn(error);
    }
  }, [useMiniMode, isUseMiniModeKey]);
  return /*#__PURE__*/_react.default.createElement(_Context.default.Provider, {
    value: {
      isDesktop,
      isDesktopOpen,
      isMobileOpen,
      setDesktopOpen,
      setMobileOpen,
      isAuthMenuOpen,
      setAuthMenuOpen,
      isMini,
      setMini,
      useMiniMode,
      setMiniMode
    }
  }, children);
};

Provider.propTypes = process.env.NODE_ENV !== "production" ? {
  children: _propTypes.default.any
} : {};
var _default = Provider;
exports.default = _default;
module.exports = exports.default;